
import Globals, OFS, os
from Globals import DTMLFile
from OFS.ObjectManager import ObjectManager
from App.ApplicationManager import ApplicationManager
from Acquisition import aq_base
from zLOG import LOG, INFO

import QuickLinks

def installControlPanel(context, panelClass):
    app = context._ProductContext__app
    cp = app.Control_Panel
    id = panelClass.id
    if 0: # Enable to clean up the control panel.
        try: del cp._objects
        except: pass
    cp.id # Unghostify.
    if cp.__dict__.has_key('_objects'):
        # _objects has been overridden.  We have to persist.
        existing = getattr(aq_base(cp), id, None)
        if existing is None or existing.__class__ != panelClass:
            cp._setObject(id, panelClass())
    else:
        # Don't persist what we don't have to.
        objects = ApplicationManager._objects
        objects = filter(lambda o, id=id: o['id'] != id, objects)
        ApplicationManager._objects = objects + (
            {'id':id, 'meta_type':panelClass.meta_type},)
        try: delattr(cp, id)
        except: pass
        setattr(ApplicationManager, id, panelClass())
    return cp._getOb(id)

_prodname = __name__.split('.')[-1]

def createIcon(iconspec, _prefix, pid=_prodname):
    name = os.path.split(iconspec)[1]
    res = 'misc_/%s/%s' % (pid, name)
    icon = Globals.ImageFile(iconspec, _prefix)
    icon.__roles__=None
    if not hasattr(OFS.misc_.misc_, pid):
        setattr(OFS.misc_.misc_, pid, OFS.misc_.Misc_(pid, {}))
    getattr(OFS.misc_.misc_, pid)[name]=icon
    return res

def initialize(context):
    installControlPanel(context, QuickLinks.QuickLinks)
    QuickLinks.QuickLinks.icon = createIcon('www/fast.gif', globals())


def LogMessage(version, externaleditor=1):
    if externaleditor:
	m = "Patch ExternaEditor %s manage_main to work with QuickLinks"
	m = m%version
    else:
	m = "Patch manage_main to work with QuickLinks"
    LOG("QuickLinks", INFO, m)
    
try:
    from Products.ExternalEditor import ExternalEditor
    _places = [INSTANCE_HOME, SOFTWARE_HOME]
    _places.append(os.path.join(INSTANCE_HOME, 'lib','python'))
    for lib_dir in _places:
        p=os.path.join(lib_dir, 'Products', 'ExternalEditor','version.txt')
        if os.access(p, os.R_OK):
            break
    ee_ver=open(p,'r')
    ver=ee_ver.read().strip()
    ee_ver.close()
    if ver.startswith('0.7'):
	LogMessage(0.7)
	rep = 'manage_main_ee071'
    elif ver.startswith('0.6'):
	LogMessage(0.6)
        rep = 'manage_main_ee06'
    elif ver.startswith('0.5'):
	LogMessage(0.5)
        rep = 'manage_main_ee05'
    else:
	LogMessage('')
        rep = 'manage_main_ee'
    ObjectManager.manage_main = DTMLFile(rep, globals())
    del _places
except:
    LogMessage('', 0)
    ObjectManager.manage_main = DTMLFile('manage_main', globals())
    
